  {  ASCII Codes Editor , version  3.0
     Programmed by Levchenya Alexander
     Saint-Petersburg ,  27.3.98 }

  unit AceUnit;
  interface
  uses Dos,Crt,AlexLib,AlexCom2,AlexArg;

  type CodeLbl=array[1..6] of string[18];
  const BufS=5120;
        TempFlag:boolean=false;

  var Stroka1,Stroka2,InStr:string;
      CodeArr:array [128..255,1..2] of byte;
      InBuf,OutBuf:array[1..BufS] of byte;
      Table:file of byte;
      Tempera:file;
      MyLbl:CodeLbl;
      BasLbl,TabFileName:string;
      Result:integer;
      Long,HowCodes,InCode,OutCode:byte;
      Stroka,SrcName,Trgtname:string;
      STflag,SecondCode:byte;

      Codes:Questions;
      KnownCodes:byte;

      LogF:text;

    procedure MyWriteln(Arg:string);

    procedure SetCodes;
    function Translate(InFile:string;OutFile:string;Code:byte):byte;
    function TransNew(InFile,OutFile:string;InCode,OutCode:byte):byte;
    function Analys(InStr:string):byte;
    procedure CheckCmdLine;
    function Decode(Ch:byte):byte;
    procedure GetReady(Code1,Code2:byte);
    function Two2One(Code:byte;Source:boolean):byte;

  implementation

    procedure MyWriteln(Arg:string);
    begin
      writeln(LogF,Arg);
      flush(LogF);
    end;

    procedure SetCodes;
    var F:text;
        Loop:byte;
        CodeFileName:string;
    begin
      CodeFileName:='CODES.ACE';
      {$I-}
      Assign(F,ProgPath+CodeFileName);
      Reset(F);
      {$I+}
      if IOResult>0 then
        begin
          writeln('Could not open file '+CodeFileName,#13#10,'Press ENTER');
          readln;
          Halt;
        end;
      readln(F,KnownCodes);
      Inc(KnownCodes);
      Codes[1]:='Alternative';
      for Loop:=2 to KnownCodes do
        readln(F,Codes[Loop]);
      close(F);
    end;

    { ERRORS:
      0 - O.K.
      1 - Error writing target
      2 - InCode=OutCode
      3 - InCode=0 or OutCode=0
    }

    function TransNew(InFile,OutFile:string;InCode,OutCode:byte):byte;
    var F:file;
        Code:byte;
        TmpFile:string;

    begin
      if InCode=OutCode then
        begin
          TransNew:=2;
          Exit;
        end;
      if (InCode=0) or (OutCode=0) then
        begin
          TransNew:=3;
          Exit;
        end;
      if InCode=1 then
        begin
          Code:=(OutCode-2)*2;
          TransNew:=Translate(InFile,OutFile,Code);
          Exit;
        end;
      if OutCode=1 then
        begin
          Code:=(InCode-2)*2+1;
          TransNew:=Translate(InFile,OutFile,Code);
          Exit;
        end;
      TmpFile:=GetEnv('TMP')+'\ACE.TMP';
      Code:=Translate(InFile,TmpFile,(InCode-2)*2+1);
      if Code=0 then Code:=Translate(TmpFile,OutFile,(OutCode-2)*2);
      Assign(F,TmpFile);
      Reset(F);
      Erase(F);
      TransNew:=Code;
    end;

    function Decode(Ch:byte):byte;
    begin
      if Ch>127 then Decode:=CodeArr[CodeArr[Ch,1],2]
                else Decode:=Ch;
    end;

    function Two2One(Code:byte;Source:boolean):byte;
    begin
      if Source then Two2One:=(Code-2)*2
                else Two2One:=(Code-2)*2+1;
    end;

    procedure GetReady(Code1,Code2:byte);
    var I:byte;
    begin
      if Code1=0 then
        for I:=128 to 255 do CodeArr[I,1]:=I
      else
        begin
          Seek(Table,Code1*128);
          for I:=128 to 255 do read(Table,CodeArr[I,1]);
        end;
      if Code2=0 then
        for I:=128 to 255 do CodeArr[I,2]:=I
      else
        begin
          Seek(Table,Code2*128);
          for I:=128 to 255 do read(Table,CodeArr[I,2]);
        end;
    end;

    function Translate(InFile:string;OutFile:string;Code:byte):byte;
    var NumLine,TransChar,I,Step:word;
        Size:longint;
        InF,OutF:file;
        TmpFile,Stroka:string;
        J,Result:byte;
        MustRead:integer;
        D:DirStr;
        N:NameStr;
        E:ExtStr;
    begin
      GetReady(Code,0);
      {}
      FSplit(InFile,D,N,E);
      TmpFile:=D+'acetmp.txt';
      {}
      Assign(InF,InFile);
      Reset(InF,1);
      {}
      Size:=FileSize(InF);
      Step:=(Size div 40)+1;
      MustRead:=(Size div BufS)+1;
      {}
      if InFile=OutFile then Assign(OutF,TmpFile)
                        else Assign(OutF,OutFile);
      Rewrite(OutF,1);
      Result:=0;
      repeat
        Dec(MustRead);
        BlockRead(InF,InBuf,BufS,TransChar);
        for I:=1 to TransChar do
          begin
            OutBuf[I]:=Decode(InBuf[I]);
          end;
        BlockWrite(OutF,OutBuf,TransChar,I);
        if TransChar<>I then
          Result:=1;
      until MustRead=0;
      close(InF);
      close(OutF);
      {}
      if InFile=OutFile then
        begin
          Erase(Inf);
          Rename(OutF,OutFile)
        end;
      Translate:=Result
    end;

  function Analys(InStr:string):byte;
  var Loop,Res:byte;
  begin
    Res:=0;
    for Loop:=1 to KnownCodes do
      if UpString(Codes[Loop])=UpString(InStr) then Res:=Loop;
    Analys:=Res;
  end;

  procedure CheckCmdLine;
  var Loop:byte;
  begin
    if ParamCount>0 then
      begin
        if IsParam('/?') then
          begin
writeln('ASCII Codes Editor v3.01'+#13#10+
        'Command line options'+#13#10+
        #13#10+
        'Usage: ACE301 /? for this help screen'+#13#10+
        '       ACE301 /T <source> <target> <source code> <target code>');
writeln('codes are numbers or names of supported codes:'+#13#10+
        '1 - Alternative, and other from file CODES.ACE'+#13#10+
        'with number 2, 3 etc.');
        for Loop:=1 to KnownCodes do
          writeln(Loop,' ',Codes[Loop]);
writeln('       ACE301 [/D <2 drive letters>] -'+#13#10+
        'interactive version of ACE'+#13#10+
        'Drive letters choose 2 drives to show at start'+#13#10+
        'Press ENTER...');
            readln;
            Halt;
          end;
        if UpString(ParamStr(1))='/T' then
          begin
            SrcName:=ParamStr(2);
            TrgtName:=ParamStr(3);

            InStr:=ParamStr(4);
            if InStr[1] in ['0'..'9']
              then Val(InStr,InCode,Result)
              else InCode:=Analys(InStr);

            InStr:=ParamStr(5);
            if InStr[1] in ['0'..'9']
              then Val(InStr,OutCode,Result)
              else OutCode:=Analys(InStr);
            writeln('Translate',#13#10,
              'from ',UnLongPath(SrcName,19,Long),' (',Codes[InCode],')',#13#10,
              'to   ',UnLongPath(TrgtName,19,Long),' (',Codes[OutCode],')');
            InCode:=TransNew(SrcName,TrgtName,InCode,OutCode);
            case InCode of
              0:writeln('Complete, press ENTER');
              1:writeln('Error writeng taget file, press ENTER');
              2:writeln('Target code is same as source, press ENTER');
              3:writeln('Unknown code, press ENTER');
            end;
    { ERRORS:
      0 - O.K.
      1 - Error writeng target
      2 - InCode=OutCode
      3 - InCode=0 or OutCode=0
    }
            readln;
            Halt;
          end
      end
  end;

  procedure StartAce;
  begin
    TabFileName:='TABLES.ACE';
    {$I-}
    Assign(Table,ProgPath+TabFileName);
    Reset(Table);
    {$I+}
    if IOResult>0 then
      begin
        writeln('Could not open file '+TabFileName,#13#10,'Press ENTER');
        readln;
        Halt;
      end;
    HowCodes:=(FileSize(Table) div 256);
    SetCodes;
  end;

  begin
    StartAce;
    CheckCmdLine;
  end.
